####################################################################
#  Copyright (c) Amir Hermelin 1999
# 
#  This software may be freely used and distributed provided:
#  1) No charge is made for this software.
#  2) This and the following copyright statements are retained.
#  3) User accepts that this software is provided "AS IS"
#  with NO WARRANTIES WHATSOEVER, including but not limited to
#  merchantability, fitness for a particular purpose, and non-
#  infringement; and accepts SOLE LIABILITY for any consequences
#  whatsoever arising directly or indirectly from any use or
#  misuse of this software or related documentation.
#  4) User agrees that the author is under no obligation to
#  maintain, update, modify, support or enhance this software
#  or related documentation.
####################################################################


# Note: change this to fit your particular installation type
package require tputs

# Load the database using a dummy command
tputs -exact

################################################################
# tputs_drawBorder
#
# Displays a border.
################################################################
proc tputs_drawBorder { } {   
   # Get row and column information
   set rows [tputs_getNum <li>]
   set cols [tputs_getNum <co>]
   set lastrow [expr $rows - 1]
   set lastcol [expr $cols - 1]
   
   # Upper line
   # <Save cursor position>, <go to home position>, <turn on reverse video>
   tputs -nonewline <sc><ho><mr>
   for { set i 0 } { $i < $cols } { incr i } {
      puts -nonewline -
   }
   # Side borders
   for { set i 1 } { $i < $rows - 1 } { incr i } {
      # <Change cursor position>, <Change cursor position>
      tputs -nonewline "<cm,$i,0>|<cm,$i,$lastcol>|"
   }
   # Bottom line
   # <Change cursor position>
   tputs -nonewline <cm,$lastrow,0>
   for { set i 0 } { $i < $cols - 1 } { incr i } {
      puts -nonewline -
   }
   
   # <Turn off reverse video>, <restore cursor position>
   tputs <me><rc>
}


################################################################
# tputs_showText
#
# Displays some text capabilities.
################################################################
proc tputs_showText {} {
   tputs "<bl>This sounds the bell"
   tputs "<mb>This is blinking text<me>"
   tputs "<md>This is bold text<me>"
   tputs "<mr>This is highlight text<me>"
   tputs "<us>This is underlined text<ue>"
   tputs "<mb><md><us>..And this is combination text<me><ue>"
}


################################################################
# tputs_showTime
#
# Activates an on screen clock, updated every 1 second, in the
#  top right corner of the screen.
################################################################
proc tputs_showTime { } {
   tputs "Activated.."

   # Register the "showTime" event ..
   after 100 tputs_showTime_int
   # .. and activate event loop
   vwait forever
}

# The showTime event handler (is called every second)
proc tputs_showTime_int { } {
   # Get number of screen columns
   set cols     [tputs_getNum <co>]
   
   # Get time
   set currTimeInSeconds [clock seconds]
   set currTimeInString  [clock format $currTimeInSeconds -format "%H:%M:%S"]

   # Calculate starting column
   set startcol [expr $cols - [string length $currTimeInString ] - 1]

   # <Save cursor>, <change cursor position>, <turn on highlight>
   tputs -nonewline "<sc><cm,0,$startcol><mr>"
   tputs -nonewline $currTimeInString
   # <Turn off highlight>, <restore cursor position>
   tputs -nonewline "<me><rc>"
   flush stdout

   # Register the next "showTime" event
   after 1000 _showTime
}
